sub verify_user($$) {

	use Net::LDAP;

	my $SERVER="ldap.unl.pt";
	my $SEARCH_BASE="ou=agentes,dc=fct,dc=unl,dc=pt";
	my $LOGIN_ATTR="uid";
	my $LDAP_FILTER="(objectClass=agenteUNL)";

	my $user = shift;
	my $pass = shift;

	my $ldap = Net::LDAP->new($SERVER);

	my $mesg = $ldap->start_tls(sslversion => 'tlsv1',
					ciphers => 'ALL',
					verify => 'none');

	$mesg = $ldap->bind ;

	$mesg = $ldap->search( base   => "$SEARCH_BASE",
			scope => "one",
			filter => "(&(".$LOGIN_ATTR."=".$user.")".$LDAP_FILTER.")",
			attrs => "uniqueIdentifier"
	);


	if (($mesg->code) || (!$mesg->entries)) {
		$mesg = $ldap->unbind;
		return undef;
	} else {

		my $DN = $mesg->entry(0)->dn;

		$mesg = $ldap->unbind;

		my $ldap = Net::LDAP->new($SERVER);

		my $mesg = $ldap->start_tls(verify => 'none');

		$mesg = $ldap->bind( $DN, password => $pass);

		if ($mesg->error eq "Success") {
			$mesg = $ldap->unbind;
			return true;
		} else {
			$mesg = $ldap->unbind;
			return undef;
		}
	}
}
1;
