#!/usr/bin/perl -Tw
#This is IP_AUTH_HACK auth.cgi
#$Revision: 1.7 $ <steffen@dett.de> 

use CGI;

my $fifo_file = "/var/run/squid/ip_auth.fifo";
my $lang="en"; #only "de" supported, all others are for english
my %mess;

my $cgi=new CGI;

if ($lang eq "de") {
	%mess = ( 
	'fifo_err'	=> 'FATAL - kann nicht mit Auth-Server kommunizieren!',
	'logout_wait'	=> 'Bitte warten Sie auf das Logout...',
	'logout_info'	=> 'Informationen &uuml;ber das Abmelden',
	'info'		=> 'Information',
	'val'		=> 'Wert',
	'src'		=> 'Quelle',
	'addr'		=> 'Addresse',
	'wait'		=> 'Abmeldung erfolgt, bitte warten...',
	'success'	=> 'Abmeldung erfolgreich durchgefhrt.',
	'connection'	=> 'Verbindung',
	'proxy'		=> 'Proxy' );
} else { #english
	%mess = ( 
	'fifo_err'	=> 'FATAL - cannot communicate with auth-server!',
	'logout_wait'	=> 'Please wait for logout...',
	'logout_info'	=> 'Available logout informations',
	'info'		=> 'Information',
	'val'		=> 'Value',
	'src'		=> 'Source',
	'addr'		=> 'Address',
	'wait'		=> 'Logout in progress, please wait...',
	'success'	=> 'You have been logged out successfully.',
	'connection' 	=> 'Connection',
	'proxy'		=> 'Proxy' );
}

sub red(@)
{
	if ($#_ == 0) {
		return ('<FONT COLOR="RED">' . $_[0] . '</FONT>');
	} else {
		return ('<FONT COLOR="RED">' , @_ , '</FONT>');
	}
}

sub print_fifo(@)
{
	if (!open(PIPE, ">>$fifo_file")) {
		print $cgi->h1(red($mess{'fifo_err'})), "(open)\n";
		print "\n", $cgi->end_html, "\n";
		die ("$0: FIFO open failed [$!]");
	}
	if (!print(PIPE @_)) {
		print $cgi->h1(red($mess{'fifo_err'})), "(write)\n";
		print "\n", $cgi->end_html, "\n";
		die ("$0: FIFO write failed [$!]");
	}
	if (!close(PIPE)) {
		print $cgi->h1(red($mess{'fifo_err'})), "(close)\n";
		print "\n", $cgi->end_html, "\n";
		die ("$0: FIFO close failed [$!]");
	}
}

#IP Address to logout
my $addr = $ENV{'REMOTE_ADDR'}; 
my $addr_info = $mess{'connection'};

if (defined $ENV{'HTTP_X_FORWARDED_FOR'}) {
	$addr = $ENV{'HTTP_X_FORWARDED_FOR'};
	$addr_info = $mess{'proxy'}; 
}

print $cgi->header(), "\n";
print $cgi->start_html(-title=>"Logout", -bgcolor=>"white"), "\n";

print $cgi->h1($mess{'logout_wait'}), "\n";

print "\n\n<!-- Infotable -->\n";
print $cgi->table({-border=>"0", -width=>"95%", -align=>"center"},
   $cgi->Tr( $cgi->td( $cgi->table({-border=>"0", -cellpadding=>"10", 
		width=>"75%"},
	$cgi->caption($mess{'logout_info'}, "\n"),
	$cgi->Tr({-align=>CENTER,-valign=>TOP},
	[
		$cgi->th( [ $mess{'info'}, $mess{'val'}, $mess{'src'}."\n" ] ),
		$cgi->td( [ $mess{'addr'}, red($addr)."&nbsp;", $addr_info."\n" ] )
	] )
   ) ) )
);
print "\n<!-- Infotable end -->\n\n";

#Non-buffered Mode from now:
$| = 1; print "<BR>\n\n";

print $mess{'wait'}, "<BR>";

print_fifo("-$addr");

print $cgi->h1(red($mess{'success'})), "<BR>\n";

print "\n", $cgi->end_html, "\n";
